Public Class FMain
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents lbLog As System.Windows.Forms.ListBox
    Friend WithEvents btRead As System.Windows.Forms.Button
    Friend WithEvents btSelect As System.Windows.Forms.Button
    Friend WithEvents btWrite00 As System.Windows.Forms.Button
    Friend WithEvents btWriteFF As System.Windows.Forms.Button
    Friend WithEvents btOpenCOM1 As System.Windows.Forms.Button
    Friend WithEvents btOpenCOM2 As System.Windows.Forms.Button
    Friend WithEvents btOpenFind As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btOpenCOM1 = New System.Windows.Forms.Button
        Me.lbLog = New System.Windows.Forms.ListBox
        Me.btRead = New System.Windows.Forms.Button
        Me.btSelect = New System.Windows.Forms.Button
        Me.btWrite00 = New System.Windows.Forms.Button
        Me.btWriteFF = New System.Windows.Forms.Button
        Me.btOpenCOM2 = New System.Windows.Forms.Button
        Me.btOpenFind = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'btOpenCOM1
        '
        Me.btOpenCOM1.Location = New System.Drawing.Point(16, 200)
        Me.btOpenCOM1.Name = "btOpenCOM1"
        Me.btOpenCOM1.Size = New System.Drawing.Size(88, 48)
        Me.btOpenCOM1.TabIndex = 0
        Me.btOpenCOM1.Text = "Open (COM1)"
        '
        'lbLog
        '
        Me.lbLog.Location = New System.Drawing.Point(8, 8)
        Me.lbLog.Name = "lbLog"
        Me.lbLog.Size = New System.Drawing.Size(312, 173)
        Me.lbLog.TabIndex = 1
        '
        'btRead
        '
        Me.btRead.Location = New System.Drawing.Point(224, 200)
        Me.btRead.Name = "btRead"
        Me.btRead.Size = New System.Drawing.Size(88, 48)
        Me.btRead.TabIndex = 2
        Me.btRead.Text = "Read"
        '
        'btSelect
        '
        Me.btSelect.Location = New System.Drawing.Point(128, 200)
        Me.btSelect.Name = "btSelect"
        Me.btSelect.Size = New System.Drawing.Size(88, 48)
        Me.btSelect.TabIndex = 3
        Me.btSelect.Text = "Select"
        '
        'btWrite00
        '
        Me.btWrite00.Location = New System.Drawing.Point(128, 256)
        Me.btWrite00.Name = "btWrite00"
        Me.btWrite00.Size = New System.Drawing.Size(88, 48)
        Me.btWrite00.TabIndex = 4
        Me.btWrite00.Text = "Write (00)"
        '
        'btWriteFF
        '
        Me.btWriteFF.Location = New System.Drawing.Point(224, 256)
        Me.btWriteFF.Name = "btWriteFF"
        Me.btWriteFF.Size = New System.Drawing.Size(88, 48)
        Me.btWriteFF.TabIndex = 5
        Me.btWriteFF.Text = "Write (FF)"
        '
        'btOpenCOM2
        '
        Me.btOpenCOM2.Location = New System.Drawing.Point(16, 256)
        Me.btOpenCOM2.Name = "btOpenCOM2"
        Me.btOpenCOM2.Size = New System.Drawing.Size(88, 48)
        Me.btOpenCOM2.TabIndex = 6
        Me.btOpenCOM2.Text = "Open (COM2)"
        '
        'btOpenFind
        '
        Me.btOpenFind.Location = New System.Drawing.Point(16, 312)
        Me.btOpenFind.Name = "btOpenFind"
        Me.btOpenFind.Size = New System.Drawing.Size(88, 48)
        Me.btOpenFind.TabIndex = 7
        Me.btOpenFind.Text = "Open (Find)"
        '
        'FMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(328, 382)
        Me.Controls.Add(Me.btOpenFind)
        Me.Controls.Add(Me.btOpenCOM2)
        Me.Controls.Add(Me.btWriteFF)
        Me.Controls.Add(Me.btWrite00)
        Me.Controls.Add(Me.btSelect)
        Me.Controls.Add(Me.btRead)
        Me.Controls.Add(Me.lbLog)
        Me.Controls.Add(Me.btOpenCOM1)
        Me.Name = "FMain"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region
#Region "Helper Functions"
    Private Function GetHex(ByVal theByte As Byte) As String
        Dim Res As String
        Res = Hex(theByte)
        If (Res.Length < 2) Then
            Res = "0" & Res
        End If
        GetHex = Res
    End Function
    Private Sub Log(ByVal Line As System.String)
        ' Add the new line to the listbox
        lbLog.Items.Add(Line)
        ' make the last line visible
        lbLog.SelectedIndex = lbLog.Items.Count - 1
        ' display new content immediately
        lbLog.Refresh()
    End Sub
#End Region
#Region "Wrapper Functions"
    Private Function DoSelect() As Boolean
        Dim i As Integer
        Dim TagType As Byte
        Dim SerialNumber(4) As Byte ' Index 0..4
        Dim Line As String
        DoSelect = False
        Log("T4Select")
        i = T4SelectTag(TagType, SerialNumber(0))
        Log("Result = " & i)
        If i = T4_NOERROR Then
            DoSelect = True
            Line = "TagType = " & TagType & " SerialNumber ="
            For i = 0 To 4
                Line = Line & " " & GetHex(SerialNumber(i))
            Next i
            Log(Line)
        End If
    End Function
    Private Function DoRead() As Boolean
        Dim i As Integer
        Dim Data(15) As Byte ' Index 0..15
        Dim Line As String
        DoRead = False
        Log("T4Read")
        i = T4ReadData(0, 4, Data(0))
        Log("Result = " & i)
        If i = T4_NOERROR Then
            DoRead = True
            Line = "Data ="
            For i = 0 To 15
                Line = Line & " " & GetHex(Data(i))
            Next i
            Log(Line)
        End If
    End Function
    Private Function DoWrite(ByVal Values As Byte) As Boolean
        Dim i As Integer
        Dim Data(15) As Byte ' Index 0..15
        Dim Line As String
        DoWrite = False
        Log("T4Write")
        For i = 0 To 15
            Data(i) = Values
        Next
        i = T4WriteData(0, 4, Data(0))
        Log("Result = " & i)
    End Function
#End Region
#Region "Event Handlers"
    Private Sub Open(ByVal COMPortString)
        Dim i As Integer
        T4DeInit()
        Log("T4Init(""" & COMPortString & """)")
        i = T4Init(COMPortString)
        Log("Result = " & i)
    End Sub
    Private Sub btOpenCOM1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btOpenCOM1.Click
        Open("COM1:")
    End Sub
    Private Sub btOpenCOM2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btOpenCOM2.Click
        Open("COM1:")
    End Sub
    Private Sub btOpenFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btOpenFind.Click
        Dim i As Integer
        T4DeInit()
        Log("T4FindCOMPortNr")
        i = T4FindCOMPortNr()
        Log("Result = " & i)
        If (i < 10) Then
            Open("COM" & i & ":")
        Else
            Open("\\.\COM" & i)
        End If
    End Sub
    Private Sub btSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSelect.Click
        DoSelect()
    End Sub
    Private Sub btRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btRead.Click
        If DoSelect() Then
            DoRead()
        End If
    End Sub
    Private Sub btWrite00_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btWrite00.Click
        If DoSelect() Then
            DoWrite(0)
        End If
    End Sub
    Private Sub btWriteFF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btWriteFF.Click
        If DoSelect() Then
            DoWrite(255)
        End If
    End Sub
#End Region

End Class
